(* Sometimes we need Buttons with more then one line captions and
hints without installing big and (expensive) new components.
The simplest way to get is to insert #10 or #13 into the strings in the
form text-view (*.dfm).

hint='any string' --> hint='any'#10'string'

It works for ALL hints, the BitBtn- and SpeedButton-captions
and TLabel- and TStaticText-captions.

The better way is tu use the following property-editor.
It should be installed into any package.
After that you get the possibility to edit directly more-line captions and hints.
I have tested it only for version 4.

Be free to use and enhance it on your own risk.

I am glad to receive mails about using and enhancing to
rbuenning@t-online.de.

Rolf Bnning   *)

unit CHEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons,WinTypes,WinProcs,DsgnIntf, ComCtrls;

type
  {the edit-form}
  TFStrEdit = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { private-declarations }
  public
    { public-declarations }
  end;

  TCaptionEditor=Class(TStringProperty)
  public
    Procedure Edit;override;
    Function GetAttributes:TPropertyAttributes;override;
  end;

Procedure Register;

var  FStrEdit: TFStrEdit;

implementation

{$R *.DFM}

Procedure Register;
begin
 { will be registered for shown components
   and for all component-hints}
 RegisterPropertyEditor(TypeInfo(string),nil,'Hint',TCaptionEditor);
 RegisterPropertyEditor(TypeInfo(TCaption),TBitBtn,'Caption',TCaptionEditor);
 RegisterPropertyEditor(TypeInfo(TCaption),TSpeedButton,'Caption',TCaptionEditor);
 RegisterPropertyEditor(TypeInfo(TCaption),TLabel,'Caption',TCaptionEditor);
 RegisterPropertyEditor(TypeInfo(TCaption),TStaticText,'Caption',TCaptionEditor);
end;

Procedure TCaptionEditor.Edit;
begin
   FStrEdit:=TFStrEdit.Create(Application);
   with FStrEdit do
   begin
     Try
       Caption:= 'Property : ' + GetName;
       Memo1.Text:=GetStrValue;
       // gets the existing strings and inserts it into memo-field
       if ShowModal=mrOK then
       begin
         // sends strings back to property-field
         SetStrValue(Memo1.Text);
       end;
     finally
       Free;
     end;
   end;
end;

Function TCaptionEditor.GetAttributes:TPropertyAttributes;
begin
  // tells the objectinspector to create dialog
  Result:=[paDialog];
end;

var LPos : Integer;// linenumber in memo-field

procedure TFStrEdit.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 // deletes active line
 if (key=46) and (ssAlt in Shift) then
   Memo1.Lines.Delete(LPos);
end;

procedure TFStrEdit.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   // after that LPos contains then linenumber where cursor is
   LPos:=SendMessage(memo1.Handle,EM_LINEFROMCHAR,Memo1.SelStart,0);
end;

end.
